"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reduxPersist = require("redux-persist");

var _seamlessImmutable = _interopRequireDefault(require("seamless-immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createReduxFetchTransform = function createReduxFetchTransform(_ref) {
  var _ref$whitelist = _ref.whitelist,
      whitelist = _ref$whitelist === void 0 ? [] : _ref$whitelist,
      _ref$repositoryKey = _ref.repositoryKey,
      repositoryKey = _ref$repositoryKey === void 0 ? 'repository' : _ref$repositoryKey;
  return (0, _reduxPersist.createTransform)(function (inboundState, key) {
    if (key !== repositoryKey) {
      return inboundState;
    }

    return inboundState.without(function (r, resourceName) {
      return !whitelist.includes(resourceName);
    });
  }, function (outboundState, key) {
    return key === repositoryKey ? _seamlessImmutable.default.from(outboundState) : outboundState;
  });
};

var _default = createReduxFetchTransform;
exports.default = _default;